﻿using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using XSockets.NET.MVC3.Sandbox.Server;

namespace XSockets.NET.MVC3.Sandbox
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : HttpApplication
    {
        private WebSocketServer _webSocketServer;


        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new HandleErrorAttribute());
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "Default", // Route name
                "{controller}/{action}/{id}", // URL with parameters
                new {controller = "Home", action = "Index", id = UrlParameter.Optional} // Parameter defaults
                );
        }

        public void Application_End()
        {
            _webSocketServer.Stop();
        }

        protected void Application_Start()
        {
            _webSocketServer = new WebSocketServer();
            _webSocketServer.Start();

            AreaRegistration.RegisterAllAreas();

            RegisterGlobalFilters(GlobalFilters.Filters);
            RegisterRoutes(RouteTable.Routes);
        }
    }
}